package models

import (
	"gogs.mikescher.com/BlackForestBytes/goext/cryptext"
	"gogs.mikescher.com/BlackForestBytes/goext/rfctime"
)

// Admin is an Adminpanel user
type Admin struct {
	UserID       AdminUserID              `json:"id"             bson:"_id,omitempty"`
	CreationTime rfctime.RFC3339NanoTime  `json:"creationTime"   bson:"creationTime"`
	Username     string                   `json:"username"       bson:"username"`
	Email        string                   `json:"email"          bson:"email"`
	Password     cryptext.PassHash        `json:"-"              bson:"password"`
	FirstName    string                   `json:"firstName"      bson:"firstName"`
	LastName     string                   `json:"lastName"       bson:"lastName"`
	Deleted      *rfctime.RFC3339NanoTime `json:"deleted"        bson:"deleted"`
}

func (u Admin) GetFirstName() string {
	return u.FirstName
}

func (u Admin) GetLastName() string {
	return u.LastName
}

func (u Admin) GetUserID() AnyID {
	return u.UserID.AsAny()
}

func (u Admin) GetEmail() string {
	return u.Email
}

func (u Admin) GetUsername() string {
	return u.Username
}

func (u Admin) Type() UserType {
	return UserTypAdmin
}
