package models

import (
	"gogs.mikescher.com/BlackForestBytes/goext/cryptext"
	"gogs.mikescher.com/BlackForestBytes/goext/rfctime"
)

// OrgUser is an OrgUserpanel user
type OrgUser struct {
	UserID         OrgUserID                `json:"id"                bson:"_id,omitempty"`
	CreationTime   rfctime.RFC3339NanoTime  `json:"creationTime"      bson:"creationTime"`
	Username       string                   `json:"username"          bson:"username"`
	Email          string                   `json:"email"             bson:"email"`
	Password       cryptext.PassHash        `json:"-"                 bson:"password"`
	FirstName      string                   `json:"firstName"         bson:"firstName"`
	LastName       string                   `json:"lastName"          bson:"lastName"`
	Comment        string                   `json:"comment"           bson:"comment"`
	AvatarImageID  *BlobID                  `json:"avatarImageID"     bson:"avatarImageID"`
	Permissions    OrgUserPermissionList    `json:"permissions"       bson:"permissions"`
	OrganizationID OrganizationID           `json:"organizationID"    bson:"organizationID"`
	Deleted        *rfctime.RFC3339NanoTime `json:"deleted"           bson:"deleted"`
}

func (u OrgUser) GetFirstName() string {
	return u.FirstName
}

func (u OrgUser) GetLastName() string {
	return u.LastName
}

func (u OrgUser) GetUserID() AnyID {
	return u.UserID.AsAny()
}

func (u OrgUser) GetEmail() string {
	return u.Email
}

func (u OrgUser) GetUsername() string {
	return u.Username
}

func (u OrgUser) Type() UserType {
	return UserTypOrgUser
}
